using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System.Linq;

namespace Redeyes
{
public class DiviningCleavageAndNipples : MVRScript
{

    
    protected class ItemBreastsAdjustEnabledStruct 
    {
        public string uid;
        public JSONStorableBool jsb;
        
        public ItemBreastsAdjustEnabledStruct(string uid, JSONStorableBool jsb)
        {
            this.uid = uid;
            this.jsb = jsb;
        }
    }
    

    protected bool isSceneLoaded = false;
    protected bool tmpbool;
    protected struct PersonInfo 
    {
        public Atom PersonAtom;
        public bool IsFemale;
        public bool DoCleavage;
        public DAZMorph Breasts_Hang_Forward, Breasts_Move_S2S_Op;
        public DAZMorph V_Redeyes_Nipples;
        public List<JSONStorableBool> _itemEnabledJsbs;// = new List<JSONStorableBool>();
        public List<ItemBreastsAdjustEnabledStruct> ItemBreastsAdjustEnabledJSON;// = new List<ItemBreastsAdjustEnabledStruct>();
    }
    //protected PersonInfo personInfo;
    protected List<PersonInfo> ListOfPersonAtoms = new List<PersonInfo>();

    protected JSONStorableBool NippleReduceEnabledJSON = new JSONStorableBool("Nipple Reduce", true);
    protected JSONStorableBool CleavageEnabledJSON = new JSONStorableBool("Cleavage/Boob squeeze", true);


    protected JSONStorable js;
    protected DAZCharacterSelector dcs;
    protected GenerateDAZMorphsControlUI morphUI;
    protected JSONStorableFloat Breasts_Hang_Forward_amount, Breasts_Move_S2S_Op_amount,  morph_speed;// = 2f;
    protected JSONStorableFloat V_Redeyes_Nipples_amount;// = 2f;
    
    protected float lastActionTime = 0f;
    protected float actionInterval = 0.25f; 

    protected void syncPersonAtoms()
    {
        if(isSceneLoaded)
        {
            //SuperController.LogMessage("syncPersonAtoms");
            foreach (PersonInfo personInfo in ListOfPersonAtoms)
            {
                //SuperController.LogMessage(personInfo.PersonAtom.name + " ItemBreastsAdjustEnabledJSON.Count " + personInfo.ItemBreastsAdjustEnabledJSON.Count + " _itemEnabledJsbs " + personInfo._itemEnabledJsbs.Count + " personInfo.DoCleavage " + personInfo.DoCleavage);
                foreach(var tmpjsb in personInfo._itemEnabledJsbs)
                {
                    tmpjsb.setJSONCallbackFunction -= OnToggleItem;
                }
                personInfo._itemEnabledJsbs.Clear();
                foreach(var tmpjsb in personInfo.ItemBreastsAdjustEnabledJSON)
                {
                    tmpjsb.jsb.setJSONCallbackFunction -= OnToggleItem;
                }
                personInfo.ItemBreastsAdjustEnabledJSON.Clear();
            }
            ListOfPersonAtoms.Clear();
            
            List<Atom> tmp_ListOfPersonAtoms;
            tmp_ListOfPersonAtoms = SuperController.singleton.GetAtoms().Where(atom => atom.type == "Person").ToList();

            foreach (Atom personAtom in tmp_ListOfPersonAtoms)
            {
                PersonInfo personInfo;
                personInfo.PersonAtom = personAtom;
                personInfo._itemEnabledJsbs = new List<JSONStorableBool>();
                personInfo.ItemBreastsAdjustEnabledJSON = new List<ItemBreastsAdjustEnabledStruct>();
                if (personAtom.type == "Person")
                {
                    js = personAtom.GetStorableByID("geometry");
                    dcs = js as DAZCharacterSelector;
                    morphUI = dcs.morphsControlUI;
                     if (morphUI.GetMorphByDisplayName("Breasts Hang Forward") == null || morphUI.GetMorphByDisplayName("Breasts Move S2S Op") == null)
                    {
                        personInfo.IsFemale=false;
                        personInfo.DoCleavage = false;
                        personInfo.Breasts_Hang_Forward  = null;
                        personInfo.Breasts_Move_S2S_Op  = null;
                        personInfo.V_Redeyes_Nipples = null;
                    }
                    else
                    {
                        personInfo.IsFemale=true;
                        personInfo.Breasts_Hang_Forward  = morphUI.GetMorphByDisplayName("Breasts Hang Forward");
                        personInfo.Breasts_Move_S2S_Op  = morphUI.GetMorphByDisplayName("Breasts Move S2S Op");
                        personInfo.V_Redeyes_Nipples = morphUI.GetMorphByDisplayName("V-Redeyes_Nipples 4 long");

                        var geometry = (DAZCharacterSelector) personAtom.GetStorableByID("geometry");
                        personInfo.DoCleavage = false;
                        foreach(string boolParamName in geometry.GetBoolParamNames())
                        {
                            if(!boolParamName.StartsWith("clothing:"))
                            {
                                continue;
                            }
                            string uid = boolParamName.Replace("clothing:", "");
                            if(uid == "Clothing Creator")
                            {
                                continue;
                            }

                            var jsb = geometry.GetBoolJSONParam(boolParamName);
                            jsb.setJSONCallbackFunction += OnToggleItem;
                            personInfo._itemEnabledJsbs.Add(jsb);

                            var dazItem = geometry.GetClothingItem(uid);

                            if(jsb.val)
                            {
                                JSONStorableBool dazItemBool = new JSONStorableBool(uid, dazItem.adjustFemaleBreastJointSpringAndDamper);
                                dazItemBool.setJSONCallbackFunction += OnToggleItem;
                                personInfo.ItemBreastsAdjustEnabledJSON.Add(new ItemBreastsAdjustEnabledStruct(uid, dazItemBool));

                                if(dazItem.adjustFemaleBreastJointSpringAndDamper)
                                {
                                    personInfo.DoCleavage = true;
                                }
                            }
                        }
                        //SuperController.LogMessage(personInfo.PersonAtom.name + " ItemBreastsAdjustEnabledJSON.Count " + personInfo.ItemBreastsAdjustEnabledJSON.Count + " _itemEnabledJsbs " + personInfo._itemEnabledJsbs.Count + " personInfo.DoCleavage " + personInfo.DoCleavage);
                    }
                }
                else
                {
                    personInfo.IsFemale = false;
                    personInfo.DoCleavage = false;
                    personInfo.Breasts_Hang_Forward = null;
                    personInfo.Breasts_Move_S2S_Op = null;
                    personInfo.V_Redeyes_Nipples = null;
                }
                ListOfPersonAtoms.Add(personInfo);
            }
        }
    }
    
    void OnToggleItem(JSONStorableBool jsb)
    {
        StartCoroutine(DelayedAction());
    }
    
    IEnumerator DelayedAction()
    {
        yield return new WaitForSeconds(0.2f); // Wait for 2 seconds
        // Perform your action here
        syncPersonAtoms();
    }

    // Create VaM-UI Float slider
    public static JSONStorableFloat SetupSlider(MVRScript script, string format, string label, float defaultValue, float minValue, float maxValue, bool rightSide)
    {
        JSONStorableFloat storable = new JSONStorableFloat(label, defaultValue, minValue, maxValue, true, true);
        storable.storeType = JSONStorableParam.StoreType.Full;
        UIDynamicSlider slidertmp = script.CreateSlider(storable, rightSide);
        slidertmp.valueFormat = format;
        script.RegisterFloat(storable);
        return storable;
    }

    // Create VaM-UI Toggle button
    public static JSONStorableBool SetupToggle(MVRScript script, string label, bool defaultValue, bool rightSide)
    {
        JSONStorableBool storable = new JSONStorableBool(label, defaultValue);
        storable.storeType = JSONStorableParam.StoreType.Full;
        script.CreateToggle(storable, rightSide);
        script.RegisterBool(storable);
        return storable;
    }

    public override void Init()
    {
        UIDynamicTextField text = null;
        try
        {

            foreach (var storable in SuperController.singleton
                .GetComponentInChildren<MVRPluginManager>()
                .GetComponentsInChildren<MVRScript>()
                .Where(s => s.name.Contains("Redeyes.DiviningCleavageAndNipples")))
            {
                if(containingAtom.type == "CoreControl")
                {
                    SuperController.LogMessage($"Redeyes.DiviningCleavageAndNipples already running as a session plugin - exiting as scene plugin");
                    DestroyImmediate(this);
                    return;
                }
            }

            
            if (containingAtom.type != "CoreControl" && containingAtom.type != "SessionPluginManager")
            {
                SuperController.LogError($"Please load DiviningLipsAndHands as a Session or Scene Plugin, not with a '{containingAtom.type}' atom.");
                DestroyImmediate(this);
                return;
            }

            SuperController.singleton.onSceneLoadedHandlers += OnSceneLoaded;
            SuperController.singleton.onAtomUIDsChangedHandlers += OnAtomUIDsChanged;
            //SuperController.singleton.onAtomUIDsWithRigidbodiesChangedHandlers += OnAtomUIDsWithRigidbodiesChanged;
            SuperController.LogMessage("Starting DiviningCleavageAndNipples");

// LEFT SIDE

            
            CleavageEnabledJSON.storeType = JSONStorableParam.StoreType.Full;
            CleavageEnabledJSON.setCallbackFunction += (bool isChecked) => {
                cleanup();
            };
            RegisterBool(CleavageEnabledJSON);
            CreateToggle(CleavageEnabledJSON, false);
            Breasts_Hang_Forward_amount = SetupSlider(this,"F2", "Breasts Hang Forward", 0.5f, -0.5f, 2f, false);
            Breasts_Move_S2S_Op_amount = SetupSlider(this,"F2", "Breasts Move S2S Op", 0.5f, -0.5f, 2f, false);

            NippleReduceEnabledJSON.storeType = JSONStorableParam.StoreType.Full;
            NippleReduceEnabledJSON.setCallbackFunction += (bool isChecked) => {
                cleanup();
            };
            RegisterBool(NippleReduceEnabledJSON);
            CreateToggle(NippleReduceEnabledJSON, false);

            V_Redeyes_Nipples_amount = SetupSlider(this,"F2", "Nipples Reduce", -0.5f, -3f, 3f, false);

            morph_speed = SetupSlider(this,"F2", "Morph speed", 2f, 0.1f, 10f, false);

            StartCoroutine(WaitForLoadingComplete());
        }
        catch (Exception e)
        {
            SuperController.LogError($"{nameof(DiviningCleavageAndNipples)}.{nameof(Init)}: {e}");
        }
    }

        private IEnumerator WaitForLoadingComplete()
        {
            while (SuperController.singleton.isLoading)
            {
                isSceneLoaded = false;
                yield return null;
            }

            while (SuperController.singleton.freezeAnimation)
            {
                isSceneLoaded = false;
                yield return null;
            }

            yield return null;

            isSceneLoaded = true;
            syncPersonAtoms();
        }

        private void OnSceneLoaded()
        {
            try {
                isSceneLoaded=true;
                syncPersonAtoms();
            }
            catch (Exception e) {
                SuperController.LogError("Exception caught in OnSceneLoaded: " + e);
            }
        }

        private void OnAtomUIDsChanged(List<string> atomUIDs)
        {
            try {
                //SuperController.LogMessage("OnAtomUIDsChanged");
                if (!isSceneLoaded) return;
                var sctrl = SuperController.singleton;
                if (sctrl.isLoading) return;

                syncPersonAtoms();
            }
            catch (Exception e) {
                SuperController.LogError("Exception caught in OnAtomUIDsChanged: " + e);
            }
        }

        /*private void OnAtomUIDsWithRigidbodiesChanged(List<string> atomUIDs)
        {
            try {
                //SuperController.LogMessage("OnAtomUIDsWithRigidbodiesChanged");
            }
            catch (Exception e) {
                SuperController.LogError("Exception caught in OnAtomUIDsChanged: " + e);
            }
        }*/


    public void OnEnable()
    {
        try
        {
            syncPersonAtoms();
            //SuperController.LogMessage($"{nameof(DiviningCleavageAndNipples)} enabled");
        }
        catch (Exception e)
        {
            SuperController.LogError($"{nameof(DiviningCleavageAndNipples)}.{nameof(OnEnable)}: {e}");
        }
    }

    public void cleanup()
    {
        foreach (PersonInfo personInfo in ListOfPersonAtoms)
        {
            if (personInfo.PersonAtom.type == "Person")
            {
                foreach(var jsb in personInfo._itemEnabledJsbs)
                {
                    jsb.setJSONCallbackFunction -= OnToggleItem;
                }
                foreach(var tmpjsb in personInfo.ItemBreastsAdjustEnabledJSON)
                {
                    tmpjsb.jsb.setJSONCallbackFunction -= OnToggleItem;
                }
                if (personInfo.IsFemale)
                {
                    personInfo.Breasts_Hang_Forward.morphValue = 0f;
                    personInfo.Breasts_Move_S2S_Op.morphValue = 0f;
                    personInfo.V_Redeyes_Nipples.morphValue = 0f;
                }
            }
        }
    }

    public void OnDisable()
    {
        try
        {
            cleanup();
            //SuperController.LogMessage($"{nameof(DiviningCleavageAndNipples)} disabled");
        }
        catch (Exception e)
        {
            SuperController.LogError($"{nameof(DiviningCleavageAndNipples)}.{nameof(OnDisable)}: {e}");
        }
    }

    public void OnDestroy()
    {
        try
        {
            cleanup();
            //SuperController.LogMessage($"{nameof(DiviningCleavageAndNipples)} destroyed");
        }
        catch (Exception e)
        {
            SuperController.LogError($"{nameof(DiviningCleavageAndNipples)}.{nameof(OnDestroy)}: {e}");
        }
    }



    // FixedUpdate is called with each physics simulation frame by Unity
    void FixedUpdate()
    {
        try
        {
            if (Time.time - lastActionTime >= actionInterval)
            {
                foreach (PersonInfo personInfo in ListOfPersonAtoms)
                {
                        //SuperController.LogMessage("personInfo " + personInfo.PersonAtom.name);
                        var geometry = (DAZCharacterSelector) personInfo.PersonAtom.GetStorableByID("geometry");
                        for (int i = 0; i < personInfo.ItemBreastsAdjustEnabledJSON.Count; i++)
                        {
                            var dazItem = geometry.GetClothingItem(personInfo.ItemBreastsAdjustEnabledJSON[i].uid); // if you need access to the item itself
                            tmpbool = dazItem.adjustFemaleBreastJointSpringAndDamper;
                            personInfo.ItemBreastsAdjustEnabledJSON[i].jsb.val = tmpbool;
                            //SuperController.LogMessage("personInfo " + personInfo.PersonAtom.name + " tmpbool " + tmpbool);
                        }
                    
                }
                lastActionTime = Time.time;
            }
            foreach (PersonInfo personInfo in ListOfPersonAtoms)
            {
                if(personInfo.IsFemale)
                {
                    if(personInfo.DoCleavage)
                    {
                        if(CleavageEnabledJSON.val)
                        {
                            personInfo.Breasts_Hang_Forward.morphValue = Mathf.Lerp(personInfo.Breasts_Hang_Forward.morphValue, Breasts_Hang_Forward_amount.val, morph_speed.val * Time.deltaTime);
                            personInfo.Breasts_Move_S2S_Op.morphValue = Mathf.Lerp(personInfo.Breasts_Move_S2S_Op.morphValue, Breasts_Move_S2S_Op_amount.val, morph_speed.val * Time.deltaTime);
                        }
                        if(NippleReduceEnabledJSON.val)
                        {
                            personInfo.V_Redeyes_Nipples.morphValue = Mathf.Lerp(personInfo.V_Redeyes_Nipples.morphValue, V_Redeyes_Nipples_amount.val, morph_speed.val * Time.deltaTime);
                        }
                    }
                    else
                    {
                            personInfo.Breasts_Hang_Forward.morphValue = Mathf.Lerp(personInfo.Breasts_Hang_Forward.morphValue, 0f, morph_speed.val * Time.deltaTime);
                            personInfo.Breasts_Move_S2S_Op.morphValue = Mathf.Lerp(personInfo.Breasts_Move_S2S_Op.morphValue, 0f, morph_speed.val * Time.deltaTime);
                            personInfo.V_Redeyes_Nipples.morphValue = Mathf.Lerp(personInfo.V_Redeyes_Nipples.morphValue, 0f, morph_speed.val * Time.deltaTime);
                    }
                }
            }
        }
        catch (Exception e)
        {
            SuperController.LogError($"{nameof(DiviningCleavageAndNipples)}.{nameof(FixedUpdate)}: {e}");
        }
    }
}

} // namespace ToumeiHitsuji end
